/*
 * dict module for eiwic
 *
 *    this uses the dict.leo.org www interface to translate
 *    words between german and english
 *
 * update: oct 9th 2004 | lordi@styleliga.org
 *    - now using pda.leo.org
 *    - added !dico for french - german translation
 *    - had to update html parsing
 *    - support for <b>-tag
 *
 * by lordi@styleliga.org | http://lordi.styleliga.org/ 2002
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <signal.h>
#include <arpa/inet.h>
#include <ctype.h>
#include <dlfcn.h>

#include "eiwic.h"
#include "plugins.h"

EP_SETNAME("dict");

#define DICTEN_CODE "ende"
#define DICTFR_CODE "frde"

#define HTMLANC_START "<input type=\"hidden\" name=\"lp\" "
#define HTMLANC_FIRST "<td class=\"td1\" valign=\"middle\" width=\"4"
#define HTMLANC_SECOND HTMLANC_FIRST

typedef struct dictionary_request {
	char channel[128];
	char request[42];
} REQ;

static void remove_tags(char *s)
{
	char *p, *t;
	
	p = s;
	
	while (*p)
	{
		switch(*p) {
			case '>':
				{
					memmove(s, p + 1, strlen(p));
					p = s;
					break;
				}
			case '<':
				if ((t = strchr(p, '>')) != NULL)
				{
					if (strncmp(p, "<B>", 3) == 0 ||
						strncmp(p, "</B>", 4) == 0)
					{
						memmove(p + 1, t + 1, strlen(t));
						*p = '\002';
					}
					else
					{				
						memmove(p, t + 1, strlen(t));
					}
					break;
				}
			case '&':
				if (strncmp(p+1, "nbsp;", 5) == 0)
				{
					memmove(p+1, p+6, strlen(p+5));
					*p = ' ';
					break;
				}				
			default:
				++p;
		}		
	}
}

int dict_looked_up(char *retrieved, void *data)
{
	REQ *req = data;
	char *p,*q,*r, *s;
	int i;
	
	p = strstr(retrieved, HTMLANC_START);

	for (i = 0; p && i < 4; ++i)
	{
		q = strstr(p, HTMLANC_FIRST);
		
		if (q == NULL)
			break;
		
		if (i == 0)
		{
			mlink->plug_sendf(
					"PRIVMSG %s :-------------- "
					"\02%s\02 --------------\r\n",
					req->channel, req->request);
		}
		
		q += strlen(HTMLANC_FIRST);
		r = strstr(q, "</td>");
		*r = 0;
		
		s = strstr(r + 1, HTMLANC_SECOND);
		s += strlen(HTMLANC_SECOND);
		
		r = strstr(s, "</td>");
		*r = 0;

		p = r + 1;
		
		remove_tags(q);
		remove_tags(s);
		
		mlink->plug_sendf("PRIVMSG %s :%s <-> %s\r\n", req->channel, q, s);	
	}
	
	if (i == 0)
	{
		mlink->plug_sendf(
				"PRIVMSG %s :---------- not found: "
				"\02%s\02 ---------\r\n", req->channel, req->request);
		return 0;
	}

	return 1;
}

int dict(char *search, char *lp, MSG *msg)
{
	REQ *r;
	char http[170];
	int i;
		
	if (search == NULL)
		return -1;

	r = malloc(sizeof(REQ));
	strncpy(r->request, search, 41);
	strcpy(r->channel, msg->to);
	
	for (i = 0; search[i]; i++) if (search[i] == ' ') search[i] = '+';

	sprintf(http, "http://pda.leo.org/?lp=%s&lang=de&searchLoc=0&cmpType=relaxed"
	              "&relink=off&sectHdr=off&spellToler=std&search=%s", lp, search);
	              
	mlink->conn_http_get(http, dict_looked_up, r);
	return 0;
}

int dict_en(char *parameter, MSG *msg)
{
	dict(parameter, DICTEN_CODE, msg);
}

int dict_fr(char *parameter, MSG *msg)
{
	dict(parameter, DICTFR_CODE, msg);
}

int ep_main()
{
	mlink->plug_trigger_reg("!dict", TRIG_PUBLIC, dict_en);
	mlink->plug_trigger_reg("!dico", TRIG_PUBLIC, dict_fr);
	
	return 1;
}
