#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <signal.h>
#include <arpa/inet.h>
#include <ctype.h>
#include <dlfcn.h>
#include <time.h>

#include "eiwic.h"
#include "plugins.h"

EP_SETNAME("info");

int on_info(char *pa, MSG *ircmsg)
{
	mlink->plug_sendf(
			"PRIVMSG %s :%s: [ \02"NAME"\02 "VERSION" ] "
			"[ %i modules / %i triggers ] [ !help for more info ]\r\n",
			ircmsg->to, ircmsg->nick, e_global->plugins.size,
			e_global->triggers.size);
	
	return 1;
}

int on_uptime(char *pa, MSG *ircmsg)
{
	int diff = time(NULL) - e_global->time_launched,
		d = (int)((diff) / 86400),
		h = (int)((diff - d * 86400) / 3600),
		m = (int)((diff - d * 86400 - h * 3600) / 60);
		/*
		s = (int)((diff - m * 60 - h * 3600));*/
		
	
	mlink->plug_sendf(
			"PRIVMSG %s :%s: [ \02"NAME"\02 "VERSION" ] "
			"[ up for %d days %d hrs %d mins ]\r\n",
			ircmsg->to, ircmsg->nick,
			d, h, m);

	return 1;
}

int on_help(char *pa, struct eiwic_ircmsg *ircmsg)
{
	TRIGGER *t;
	PLUGIN *p;
	char buf[1024];
	int o, i = 0;
	DListElmt *el, *elt;
	
	sprintf(buf,
			"PRIVMSG %s :"
			"Eiwic ("VERSION") HELP:\r\nPRIVMSG %s :",
			ircmsg->to, ircmsg->to);
		
	FOR_EACH(&e_global->plugins, el)
	{
		p = el->data;
				
		if (i != 0) strcat(buf, "; ");
		i = 0;
		
		FOR_EACH(&e_global->triggers, elt)
		{
			t = elt->data;
						
			if (t->plugin == p)
			{
				if (i == 0)
				{
					strcat(buf, "\02");
					strcat(buf, t->plugin->name);
					strcat(buf, "\02: ");
				}
				else
					strcat(buf, ", ");
				
				strcat(buf, t->trigger);
				++i;
				++o;
			}
		}
		
		if (o > 5)
		{
			strcat(buf, "\r\nPRIVMSG ");
			strcat(buf, ircmsg->to);
			strcat(buf, " :");
			o = 0; i = 0;
		}
	}
	
	strcat(buf, "\r\n");
	mlink->plug_send(buf);
		
	return 1;
}

int ep_main()
{	
	mlink->plug_trigger_reg("!info", TRIG_PUBLIC, on_info);
	mlink->plug_trigger_reg("!help", TRIG_PUBLIC, on_help);
	mlink->plug_trigger_reg("!up", TRIG_PUBLIC, on_uptime);
	
	return 1;
}

