#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <dlfcn.h>

#include "eiwic.h"
#include "plugins.h"

EP_SETNAME("translate");

typedef struct translation_request {
	char channel[128];
	char nick[32];
	char *lang_to;
	char *lang_from;
} REQ;

int translated(char *retrieved, void *data)
{
	REQ *req = data;

	mlink->plug_sendf(
			"PRIVMSG %s :%s, [%s] %s\r\n",
			req->channel, req->nick, req->lang_to, retrieved);	

	return 1;
}

char *get_language(char * string)
{
	if (strncasecmp(string, "en", 2) == 0)
		return "English";

	if (strncasecmp(string, "de", 2) == 0)
		return "German";
	
	if (strncasecmp(string, "no", 2) == 0)
		return "Norwegian";
	
	if (strncasecmp(string, "it", 2) == 0)
		return "Italian";
	
	if (strncasecmp(string, "es", 2) == 0)
		return "Spanish";

	if (strncasecmp(string, "fr", 2) == 0)
		return "French";

	return NULL;
}

int translation(char *parameter, MSG *msg)
{
	REQ *r;
	char url[270];
	char *pp;
		
	if (parameter == NULL)
		return -1;
	
	r = malloc(sizeof(REQ));
	
	r->lang_from = get_language(msg->args + 1);
	r->lang_to = get_language(msg->args + 4);
	strcpy(r->channel, msg->to);
	strcpy(r->nick, msg->nick);
	
	pp = parameter;
	while (*pp++) 
	{
		if (*pp==' ') *pp='+';
		if (pp - parameter > 140)
		{
			*pp = 0;
			break;
		}
	}

	sprintf(url,
			"http://ets.freetranslation.com:5081/?"
			"Sequence=core&Mode=text&Language=%s%%2F%s&SrcText=%s",
			r->lang_from, r->lang_to, parameter);

	mlink->conn_http_get(url, translated, r);
	return 0;
}

int ep_main()
{
	mlink->plug_trigger_reg("!en-de", TRIG_PUBLIC, translation);
	mlink->plug_trigger_reg("!en-it", TRIG_PUBLIC, translation);
	mlink->plug_trigger_reg("!en-fr", TRIG_PUBLIC, translation);
	mlink->plug_trigger_reg("!en-es", TRIG_PUBLIC, translation);
	mlink->plug_trigger_reg("!en-no", TRIG_PUBLIC, translation);
	
	mlink->plug_trigger_reg("!de-en", TRIG_PUBLIC, translation);
	mlink->plug_trigger_reg("!it-en", TRIG_PUBLIC, translation);
	mlink->plug_trigger_reg("!fr-en", TRIG_PUBLIC, translation);
	mlink->plug_trigger_reg("!es-en", TRIG_PUBLIC, translation);	
	mlink->plug_trigger_reg("!no-en", TRIG_PUBLIC, translation);
	
	return 1;
}
